--NPCG = NPCG or { }
--NPCG            = NPCG            or { }
--NPCG.Interface  = NPCG.Interface  or { }
--NPCG.Options    = NPCG_Options or { }

-- NOTE: Awyzuu is making a mess!

function NPCG.LoadOptions()

  NPCG.Interface = NPCG.Interface or { }
  --NPCG.Options    = NPCG_Options or { }

  NPCG.Interface.optionsFrame = CreateFrame("Frame", "NpcgOptionsFrame", UIParent)
  NPCG.Interface.optionsFrame.name = "npcGenerator"
  
  --[[
  -- Optional function for when okay is pressed.
  NPCG.Interface.optionsFrame.okay = function()
  
  end
  
  -- Optional function for when cancel is pressed.
  NPCG.Interface.optionsFrame.cancel = function()
  
  end
  
  -- Optional function for when defaults is pressed.
  NPCG.Interface.optionsFrame.default = function()
  
  end
  
  -- Subcategories!
  NPCG.Interface.optionsFrame.parent = "npcGenerator main panel"
  --]]
  
  NPCG.Interface.optionsFrame.title = NPCG.Interface.optionsFrame:CreateFontString("VersionLabel", "ARTWORK", "GameFontNormalLarge")

  NPCG.Interface.optionsFrame.title:SetPoint("TOPLEFT", NPCG.Interface.optionsFrame, "TOPLEFT", 16, -16)
  NPCG.Interface.optionsFrame.title:SetText("NpcGenerator")

  NPCG.Interface.optionsFrame.subText = NPCG.Interface.optionsFrame:CreateFontString("VersionLabel", "ARTWORK", "GameFontHighlightSmall")
  NPCG.Interface.optionsFrame.subText:SetSize(0,32)
  NPCG.Interface.optionsFrame.subText:SetPoint("TOPLEFT", NPCG.Interface.optionsFrame.title, "BOTTOMLEFT",   0, -8)
  NPCG.Interface.optionsFrame.subText:SetPoint(  "RIGHT", NPCG.Interface.optionsFrame,            "RIGHT", -32,  0)
  NPCG.Interface.optionsFrame.subText:SetNonSpaceWrap(true)
  NPCG.Interface.optionsFrame.subText:SetJustifyH("LEFT")
  NPCG.Interface.optionsFrame.subText:SetJustifyV("TOP")
  NPCG.Interface.optionsFrame.subText:SetMaxLines(3)
  NPCG.Interface.optionsFrame.subText:SetText("These are the general options for npcGenerator. NpcGenerator is a project by Awyzuu and Acatiera. Please report any bugs or suggestions to our issuetracker at https://wow.curseforge.com/projects/npcgenerator/issues.")

  --NPCG.Options["debug"] = false

  NPCG.Interface.optionsFrame.debug = CreateFrame("CheckButton", "debugToggle", NpcgOptionsFrame, "InterfaceOptionsCheckButtonTemplate")
  NPCG.Interface.optionsFrame.debug:SetChecked(NPCG_Options["debug"])
  NPCG.Interface.optionsFrame.debug:SetPoint("TOPLEFT", NPCG.Interface.optionsFrame.subText, "BOTTOMLEFT", -2, -8)
  NPCG.Interface.optionsFrame.debug:SetScript("OnClick", function(self) NPCG_Options["debug"] = 
    self:GetChecked()
  end)
  debugToggleText:SetText("Debug Mode")

  --NPCG.Options["forceFaction"] = false

  NPCG.Interface.optionsFrame.forceFaction = CreateFrame("CheckButton", "ForceFactionToggle", NpcgOptionsFrame, "InterfaceOptionsCheckButtonTemplate")
  NPCG.Interface.optionsFrame.forceFaction:SetChecked(NPCG_Options["forceFaction"])
  NPCG.Interface.optionsFrame.forceFaction:SetPoint("TOPLEFT", NPCG.Interface.optionsFrame.debug, "BOTTOMLEFT", 0, -8)
  NPCG.Interface.optionsFrame.forceFaction:SetScript("OnClick", function(self) NPCG_Options["forceFaction"] = 
    self:GetChecked()
  end)
  ForceFactionToggleText:SetText("Match faction")


  --NPCG.Options["safeMode"] = false

  NPCG.Interface.optionsFrame.safeToggle = CreateFrame("CheckButton", "SafeModeToggle", NpcgOptionsFrame, "InterfaceOptionsCheckButtonTemplate")
  NPCG.Interface.optionsFrame.safeToggle:SetChecked(NPCG_Options["safeMode"])
  NPCG.Interface.optionsFrame.safeToggle:SetPoint("TOPLEFT", NPCG.Interface.optionsFrame.forceFaction, "BOTTOMLEFT", 0, -8)
  NPCG.Interface.optionsFrame.safeToggle:SetScript("OnClick", function(self) NPCG_Options["safeMode"] = 
    self:GetChecked()
  end)
  SafeModeToggleText:SetText("Safe Mode")

  InterfaceOptions_AddCategory(NPCG.Interface.optionsFrame)
end